<template>
  <div>
    <Toolbar :handle-submit="sendForm"></Toolbar>
    <ProductForm
      ref="createForm"
      :values="item"
      :errors="violations"
      v-on:on-images-changed="setImages"
      v-on:on-images-removed="removeImages"
    />
    <Loading :visible="isLoading" />
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import ProductForm from "../../../components/admin/product/Form";
import Loading from "../../../components/Loading";
import Toolbar from "../../../components/Toolbar";
import CreateMixin from "../../../mixins/CreateMixin";

const servicePrefix = "Product";

export default {
  name: "AdminProductCreate",
  servicePrefix,
  mixins: [CreateMixin],
  components: {
    Loading,
    Toolbar,
    ProductForm
  },
  data() {
    return {
      item: {},
      images: []
    };
  },
  watch: {
    created() {
      this.$router.push({ name: "AdminProductList" });
    }
  },
  computed: {
    ...mapFields("product", [
      "error",
      "isLoading",
      "created",
      "violations",
      "companyProducts",
      "uploadedImages"
    ])
  },
  mounted() {
    if (this.isLoading) {
      this.toggleLoading();
    }
  },
  methods: {
    ...mapActions("product", [
      "create",
      "uploadProductImages",
      "toggleLoading"
    ]),
    uploadImages: function() {
      this.images.forEach(image => {
        var formData = new FormData();
        formData.append("file", image, image.name);
        this.uploadProductImages(formData);
      });
      if (!this.isLoading)
        this.create({ product: this.item, images: this.uploadedImages });
    },
    setImages(images) {
      this.images = images;
    },
    removeImages(imageObjects, toAddImages) {
      this.images = toAddImages;
    },
    sendForm() {
      this.uploadImages();
    }
  }
};
</script>
